<template>
  <label>Redirect Urls:</label>
  <lull-datatable
    class="w-full"
    :loading="loading"
    :filter="false"
    :data="redirectUrls"
  >
    <lull-datatableColumn id="url" label="Url" />
    <lull-datatableColumn id="urlType" label="Type" width="25%" />
    <lull-datatableColumn
      id="isPrimary"
      label="Primary"
      width="10%"
      justifyContent="center"
    />

    <lull-datatableColumn width="15rem" id="actions" justifyContent="center">
      <span></span>
    </lull-datatableColumn>

    <template v-slot:actions="{ row }">
      <lull-button class="w-0.5" type="danger" @click="remove(row.id)">
        <lull-icon icon="fa-trash" />
      </lull-button>

      <lull-button class="w-0.5 ml-3" type="info" @click="edit(row)">
        <lull-icon icon="fa-edit" />
      </lull-button>
    </template>

    <template v-slot:isPrimary="{ row }">
      <lull-icon v-if="row.isPrimary" icon="fa-key" color="#D4AF37" />
      <span v-else></span>
    </template>
  </lull-datatable>

  <div class="w-full mt-2 flex justify-end">
    <lull-button type="info" @click="showModal()">New Redirect Url</lull-button>
  </div>

  <lull-modal v-model="modalVisible" width="45rem" :closableMask="false">
    <redirecturl
      :action="action"
      :clientId="clientId"
      :redirectUrl="selected"
      @close="hideModal()"
      @refresh="refresh()"
    />
  </lull-modal>

  <confirm
    v-model="confirmationModal"
    :callback="confirmationCallback"
    message="Are you sure you want to delete this redirect url?"
  />
</template>

<script lang="ts">
import { ClientRedirectUrl } from '@/core/models/client/ClientRedirectUrl';
import { ManageAction } from '@/core/types/ManageAction';
import { useStore } from '@/store';
import { ClientAction } from '@/store/Clients/ClientModule';
import { computed, ComputedRef, defineComponent, onMounted, ref } from 'vue';
import RedirectUrl from './RedirectUrl.vue';
import { Confirm } from '@/core/components';

export default defineComponent({
  name: 'redirecturls',
  components: {
    redirecturl: RedirectUrl,
    confirm: Confirm,
  },
  props: {
    clientId: { type: String, required: true },
  },
  setup(props) {
    const store = useStore();
    const selected = ref<Partial<ClientRedirectUrl>>({});
    const loading: ComputedRef<boolean> = computed(
      () => store.getters['client/redirectUrlsLoadingState']
    );
    const redirectUrls = ref<ClientRedirectUrl[]>([]);
    const modalVisible = ref<boolean>(false);
    const action = ref<ManageAction>(ManageAction.Create);
    const confirmationModal = ref<boolean>(false);
    const confirmationCallback = ref<Function | null>(null);

    function showModal(): void {
      modalVisible.value = true;
    }

    function hideModal(): void {
      action.value = ManageAction.Create;
      selected.value = { id: 0, url: '', urlType: undefined, isPrimary: false };
      modalVisible.value = false;
    }

    async function getRedirectUrls(): Promise<void> {
      const results = await store.dispatch(
        `client/${ClientAction.GetRedirectUrls}`,
        props.clientId
      );
      if (results) {
        redirectUrls.value = results;
      }
    }

    async function refresh(): Promise<void> {
      hideModal();
      await getRedirectUrls();
    }

    function edit(row: ClientRedirectUrl): void {
      action.value = ManageAction.Edit;
      selected.value = row;
      showModal();
    }

    async function remove(id: number): Promise<void> {
      const cb = async (): Promise<void> => {
        const results = await store.dispatch(
          `client/${ClientAction.DeleteRedirectUrl}`,
          id
        );

        if (results) {
          await getRedirectUrls();
        }
      };

      confirmationCallback.value = cb;
      confirmationModal.value = true;
    }

    onMounted(async () => {
      await getRedirectUrls();
    });

    return {
      selected,
      loading,
      redirectUrls,
      modalVisible,
      confirmationModal,
      confirmationCallback,
      action,
      showModal,
      hideModal,
      refresh,
      edit,
      remove,
    };
  },
});
</script>